﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WinAutomator.Library.InOut
{
    public class Connector<T> : IConnector
    {
       
        public delegate T GetObject();
        public delegate void SetObject(T obj);
        public GetObject GetProcessData;
        public SetObject SetProcessData;

        private Connector<T> _linkTo;
        
        public void LinkToConnector(Connector<T> child)
        {
            _linkTo = child;
            child._linkTo = this;
        }

        public Connector(WAInOut inout, IProcess process)
        {
            Type = inout;
            Process = process;
        }

        public override void Execute()
        {
            T obj = this.GetProcessData();
            _linkTo.SetProcessData(obj);
        }

        public override IConnector GetLinkConnector()
        {
            return _linkTo;
        }

        public override bool HasChild
        {
            get
            {
                if (_linkTo == null)
                    return false;
                return true;
            }
        }
    }
}
