﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace WinAutomator.Library.InOut
{
    public class VirtualConnector 
    {
        
        List<IConnector> _connectors = new List<IConnector>();
        public IConnector LinkedConnector { get; protected set; }

        public WAInOut VirtualConnectorType { get; protected set; }

        public VirtualConnector(WAInOut type)
        {
            VirtualConnectorType = type;
        }

        public void AddConnector(IConnector ins)
        {
            _connectors.Add(ins);
        }

        public bool TryToConnect(VirtualConnector connector)
        {
            foreach (IConnector source in _connectors)
            {
                foreach (IConnector destination in connector.Connectors)
                {
                    if (tryToConnect(source, destination))
                    {
                        Type serviceType = source.GetType();
                        MethodInfo method = serviceType.GetMethod("LinkToConnector");
                        
                        var result = method.Invoke(source, new[] { destination });

                        return true;
                    }
                }
            }
            return false;
        }

        private bool tryToConnect(IConnector source, IConnector destination)
        {
            if ((source.GetType() == destination.GetType()) && (source.Type != destination.Type))
                return true;
            return false;
        }


        public List<IConnector> Connectors
        {
            get
            {
                return _connectors;
            }
        }

        public IProcess Process
        {
            get
            {
                if (_connectors.Count > 0)
                    return _connectors[0].Process;

                return null;
                        
            }
        }

    }
}
